(* Title:  Interpret/Interpret.thy
   Author: Walther Neuper 110226
   (c) due to copyright terms

Collect all defitions for the Lucas-Interpreter
*)

theory Interpret
imports Specify.Specify
begin
  ML_file istate.sml
  ML_file "sub-problem.sml"
  ML_file "thy-read.sml"
  ML_file "li-tool.sml"
  ML_file "solve-step.sml"
  ML_file "error-pattern.sml"
  ML_file derive.sml
  ML_file "lucas-interpreter.sml"
  ML_file "step-solve.sml"

ML \<open>
local
  val thys_known_sofar = Theory.nodes_of @{theory}
  val isac_thys_known_sofar = take (
    find_index (curry Context.eq_thy ThyC.last_isabelle_thy) thys_known_sofar,
    thys_known_sofar)
  val isac_names_known_sofar = map Context.theory_name isac_thys_known_sofar
in
  val compare_dependencies__ThyC =
    if isac_names_known_sofar = ThyC.session_interpret_names @ ThyC.session_specify_names then ()
    else raise ERROR "theory dependencies not as anticipated in ThyC"
end
\<close> ML \<open>
\<close> ML \<open>
\<close>
end
